# hdemo.tcl --
#
#    ѱ ؽƮ ͸ ѰԴϴ.
#
#	Copyright (c) by 1997 () ũ
#

proc ShowHDemo {type args} {
    switch $type {
        w {
            set w [CreateBody w]
            AccessFileDialog $w.file
            CreateText $w.text
        }

        u {
            set w [CreateBody u]
            AccessFileDialog $w.file 
            CreateText $w.text
            StatusBar $w.status
            ShowStatus "/ ȯ Shift+Space "
        }

        m {
        }

        default {
        }
    }
}

proc CreateBody {platform} {
    set w .hdemo
    catch {destroy $w}
    toplevel $w
    wm title $w "Hangul Patch Demo"
    wm iconname $w "Hangul Editor"
    wm geometry $w +300+200
    
    frame $w.menuBar
    pack $w.menuBar -side top -fill x
    menubutton $w.menuBar.file -text File -menu $w.menuBar.file.m -underline 0
    menu $w.menuBar.file.m
    $w.menuBar.file.m add command -label "Ͽ... " -command "AboutBox" \
        -underline 0 -accelerator "<F1>"
    $w.menuBar.file.m add sep
    $w.menuBar.file.m add command -label "" -command "destroy $w"

    frame $w.file -relief groove -bd 1
    frame $w.text -relief groove -bd 1
    if {$platform == "u"} {
        frame $w.status -relief groove -bd 1
    }
    frame $w.buttons
    button $w.buttons.dismiss -text "" -command "destroy $w"
    button $w.buttons.code -text "ҽ ڵ" -command "showCode $w"

    pack $w.buttons -side bottom -fill x -pady 2m
    pack $w.menuBar.file -side left
    pack $w.file -side top -fill x -padx 1 -pady 2	
    if {$platform == "u"} {
        pack $w.status -side bottom -fill x -padx 1 -pady 2 
    }
    pack $w.text -side bottom -fill both -expand yes -padx 1 -pady 2 
    pack $w.buttons.dismiss $w.buttons.code -side left -expand 1
    bind $w <F1> aboutBox
    focus -force $w
    return $w
}

proc FileDialog {win {filename {}}} {
    set types {
        {"All Files"         *}
        {"Text files"		{.txt .doc}	}
        {"Tcl Scripts"		{.tcl}		TEXT}
    }

    if {$filename == {}} {
        return [tk_getOpenFile -filetypes $types -parent $win]
    } else {
        return [tk_getSaveFile -filetypes $types -parent $win \
               	            -initialfile $filename] 
    }
}

proc AccessFileDialog {win} {
    global FileDialog

    foreach del [array names FileDialog *] {
        unset FileDialog($del)
    }    
    set i 1
    foreach cmt {"" ""} {
        button $win.file$i -text $cmt -bd 1 -pady 1 -takefocus 0 \
            -highlightcolor gray 
        entry $win.fentry$i -bd 1 -bg white -textvariable FileDialog($i) \
            -highlightcolor gray
        grid $win.file$i  -in $win -row 1 -column $i -sticky ew
        grid $win.fentry$i -in $win -row 1 -column [expr $i+1] -sticky ew
        incr i 2
    }
    set base [winfo parent $win]
    bind $win.file1 <ButtonRelease> "Browse $base %W"
    bind $win.fentry1 <Return> "Browse $base %W 1"
    bind $win.file3 <ButtonRelease> "Browse $base %W"
    bind $win.fentry3 <Return> "Browse $base %W 1"

    grid rowconfigure $win 1 -weight 0 
    grid columnconfigure $win 1 -weight 0 -minsize 2
    grid columnconfigure $win 2 -weight 1 -minsize 2
    grid columnconfigure $win 3 -weight 0 -minsize 2
    grid columnconfigure $win 4 -weight 1 -minsize 2

}

proc Browse {base widget {key 0}} {
    global FileDialog

    regexp {[0-9]} $widget no
    if {$key == 1} {
        if [file isfile $FileDialog($no)] {
            set path $FileDialog($no)
        } elseif [regexp -nocase {} [[winfo parent $widget].file$no cget -text]] {
            tk_dialog .error "" "$FileDialog($no)  ʽϴ." \
                "error" 0 "Ȯ"
            set FileDialog($no) {}
            return
        }
    }

    if {$no != 1} {
        if {$FileDialog([expr $no-2]) != {}} {
            if {$FileDialog($no) == {}} {
               	set path [FileDialog $base [file tail $FileDialog([expr $no-2])]]
            } else {
               	set path [FileDialog $base [file tail $FileDialog($no)]]
            }
        } else {
            if {$FileDialog($no) == {}} {
            	set path [FileDialog $base Untitle]
            } else {
               	set path [FileDialog $base $FileDialog($no)]
            }
        }
        
        if {$path == {}} {return}
        foreach text [findwidget $base widget] {
            if [regexp -nocase text [winfo class $text]] {
                set data [$text get 1.0 end]
                break
            }
        }
        set fp [open $path w+]
        puts $fp $data
        close $fp
        set FileDialog($no) $path
    } else {
        if {$key == 0} {
            set path [FileDialog $base]
            if {$path == {}} {return}
        }
        set fp [open $path r]
        set data [read $fp]
        foreach text [findwidget $base widget] {
            if [regexp -nocase text [winfo class $text]] {
                $text delete 1.0 end
                $text insert end $data
                break
            }
        }
        close $fp
        set FileDialog($no) $path
    }
    ShowStatus "$path"	
}

proc findwidget {w var} {
    upvar #0 $var widget
    foreach subw [winfo children $w] {
        set dummy [winfo children $subw]
        if {[lindex $dummy 0] != {}} {
            set widget [findwidget $subw widget]
        } else {
            lappend widget $subw
        }
    }
    set temp $widget
    catch {unset widget}
    return $temp
}

proc CreateText {win} {
    text $win.text -highlightcolor gray -bg white -wrap none \
                   -yscrollcommand "$win.yscroll set" \
                   -xscrollcommand "$win.xscroll set"
    scrollbar $win.xscroll -command "$win.text xview" \
        -takefocus 0 -orient horizontal
    scrollbar $win.yscroll -command "$win.text yview" \
        -takefocus 0
    grid $win.text    -in $win -row 1 -column 1 -columnspan 2 -rowspan 2 -sticky news
    grid $win.xscroll -in $win -row 3 -column 1 -columnspan 2 -sticky ew
    grid $win.yscroll -in $win -row 1 -column 3 -rowspan 2 -sticky ns

    grid rowconfigure    $win 1 -weight 1 -minsize 2
    grid rowconfigure    $win 2 -weight 0 -minsize 2
    grid rowconfigure    $win 3 -weight 0 -minsize 2
    grid columnconfigure $win 1 -weight 1 -minsize 2
    grid columnconfigure $win 2 -weight 0 -minsize 2
    grid columnconfigure $win 3 -weight 0 -minsize 2
}

global Week
array set Week {
    Mon "" Tue "ȭ" Wed "" Thu "" Fri "" Sat "" Sun "" Non 1
      "" ȭ  "ȭ"   ""   ""   ""   ""   ""
}

proc StatusBar {w} {
    global StatusBar HanStatus	

    frame $w.status   
    pack $w.status -fill x -side bottom -pady 2
    set w $w.status

    foreach widget {comment mode date time} var {Comment InputMode Date Time} \
            width {10 2 8 5} {
        label $w.$widget -relief sunken -bd 1 -textvariable StatusBar($var) \
                        -anchor w -fg white -width $width
    }

    pack $w.time -side right -padx 2
    pack $w.date -side right -padx 2
    pack $w.mode -side right -padx 2
    pack $w.comment -fill x -expand yes -side left -padx 2
    pack $w -fill x -side bottom -pady 2
    set StatusBar(InputMode) $HanStatus(Mode)
    ShowDate Week StatusBar
    ShowTime Week StatusBar
    trace variable HanStatus w ChangeMode
}

proc ChangeMode {var index agrs} {
    global StatusBar
    upvar \#0 $var name

    set StatusBar(InputMode) $name($index)
}

proc ShowDate {var status} {
    upvar #0 $var Week $status StatusBar

    set date [clock format [clock seconds] -format %m/%d/%a]
    foreach {mon day week} [split $date /] {}
    set StatusBar(Date) "$mon/$day/$Week($week)"
}

proc ShowTime {var status} {
    upvar #0 $var Week $status StatusBar

    set seconds [clock seconds]
    if {$Week(Non)} {
        set StatusBar(Time) [clock format $seconds -format %H:%M]
    } else {
        set StatusBar(Time) [clock format $seconds -format "%H %M"]
    }
    set Week(Non) [expr $Week(Non)^1]

    foreach {hour min} [split $StatusBar(Time) :] {}

    if {$hour == "00" && $min == "00"} {
        ShowDate
    }

    after 1000 ShowTime Week StatusBar
}

proc ShowStatus {{comment {}} {scroll {}}} {
    global StatusBar Scrollcmt

    set StatusBar(Comment) $comment
    if {$scroll != {} && [kstring length $comment] != 0} {
        set Scrollcmt [kstring range $comment 1 end]
        after 100 ShowStatus {$Scrollcmt} scroll
        update idletasks
    } elseif [info exist Scrollcmt] {
        after cancel ShowStatus {$Scrollcmt} scroll
        unset Scrollcmt
    }
}

proc DeleteStatus {args} {
    ShowStatus 
}

proc AboutBox {} {
    tk_messageBox -icon info -type ok -title "ѱ ġ " -message \
"Tk ѱ ġ \n\n\
Copyright (c) 1997 Wins Technology, Inc."
}

ShowHDemo [string range $tcl_platform(platform) 0 0]
